<?php

include_once 'flows_data.php';

class BubblesData extends FlowsData
{

    public function getFilters()//dades seleccionades al formulari
    {
        $filters['religion']     =  filter_var( $_POST["religion"], FILTER_VALIDATE_REGEXP, array ("options" => array("regexp" => "/\w+/") ) ) ;
        $filters['year']        =  filter_var( $_POST["year"], FILTER_VALIDATE_REGEXP, array ("options" => array("regexp" => "/\w+/") ) ) ;

        return $filters;
    }

    public function prepareQuery( $filters )
    {
        $year = $filters['year'];
        $additional_condition='';

        if ( $filters['religion'] != 'all' )
        {
            $additional_condition = 'IF ( id_religio = ' . $filters['religion'] . ', cc.num_centres_' . $year . ' * 4, 0 ) as number';
        }
        else
        {
            $additional_condition = 'cc.num_centres_'. $year . ' * 4 as number';

        }

        $sql = <<<QUERY
SELECT
$additional_condition
FROM
    centre_culte cc
ORDER BY id_comarca,id_religio
QUERY;

        return $sql;

    }
}
