!function(){
	var bP={};	
	var b=5, bb=380, height=620, buffMargin=1, minHeight=10; 
	var c1=[-180, 40], c2=[-30, 190]; //Column positions of labels: c1[pais, comarca] c2[num immigrants pais, num immigrants comarca]
	var colors =["#9aa6a3", "#3f7c7d", "#402726", "#752726", "#d75931", "#e1a760", "#f8e0b1",    
				"#9aa6a3", "#3f7c7d", "#402726", "#752726", "#d75931", "#e1a760", "#f8e0b1",
				"#9aa6a3", "#3f7c7d", "#402726", "#752726", "#d75931", "#e1a760", "#f8e0b1",
				"#9aa6a3", "#3f7c7d", "#402726", "#752726", "#d75931", "#e1a760", "#f8e0b1",
				"#9aa6a3", "#3f7c7d", "#402726", "#752726", "#d75931", "#e1a760", "#f8e0b1"
				];
	
		
	
	bP.partData = function(data,p){
		var sData={};
		
		sData.keys=[
			d3.set(data.map(function(d){ return d[0];})).values()/*.sort(function(a,b){ return ( a<b? -1 : a>b ? 1 : 0);})*/,//default order
			d3.set(data.map(function(d){ return d[1];})).values().sort(function(a,b){ return ( a<b? -1 : a>b ? 1 : 0);}) //alphabet. order
		];
		
		sData.data = [
						sData.keys[0].map( function(d){ return sData.keys[1].map( function(v){ return 0; }); }),
						sData.keys[1].map( function(d){ return sData.keys[0].map( function(v){ return 0; }); }) 
		];
		
		data.forEach(function(d){ 
			sData.data[0][sData.keys[0].indexOf(d[0])][sData.keys[1].indexOf(d[1])]=d[p];
			sData.data[1][sData.keys[1].indexOf(d[1])][sData.keys[0].indexOf(d[0])]=d[p]; 
		});
		
		return sData;
	}
	
	function visualize(data){
		var vis ={};
		function calculatePosition(a, s, e, b, m){
			var total=d3.sum(a);
			var sum=0, neededHeight=0, leftoverHeight= e-s-2*b*a.length;
			var ret =[];
			
			a.forEach(
				function(d){ 
					var v={};
					v.percent = (total == 0 ? 0 : d/total); 
					v.value=d;
					v.height=Math.max(v.percent*(e-s-2*b*a.length), m);
					(v.height==m ? leftoverHeight-=m : neededHeight+=v.height );
					ret.push(v);
				}
			);
			
			var scaleFact=leftoverHeight/Math.max(neededHeight,1), sum=0;
			
			ret.forEach(
				function(d){ 
					d.percent = scaleFact*d.percent; 
					d.height=(d.height==m? m : d.height*scaleFact);
					d.middle=sum+b+d.height/2;
					d.y=s + d.middle - d.percent*(e-s-2*b*a.length)/2;
					d.h= d.percent*(e-s-2*b*a.length);
					d.percent = (total == 0 ? 0 : d.value/total);
					sum+=2*b+d.height;
				}
			);
			return ret;
		}

		vis.mainBars = [ 
			calculatePosition( data.data[0].map(function(d){ return d3.sum(d);}), 0, height, buffMargin, minHeight),
			calculatePosition( data.data[1].map(function(d){ return d3.sum(d);}), 0, height, buffMargin, minHeight)
		];
		
		vis.subBars = [[],[]];
		vis.mainBars.forEach(function(pos,p){
			pos.forEach(function(bar, i){	
				calculatePosition(data.data[p][i], bar.y, bar.y+bar.h, 0, 0).forEach(function(sBar,j){ 
					sBar.key1=(p==0 ? i : j); 
					sBar.key2=(p==0 ? j : i); 
					vis.subBars[p].push(sBar); 
				});
			});
		});
		vis.subBars.forEach(function(sBar){
			sBar.sort(function(a,b){ 
				return (a.key1 < b.key1 ? -1 : a.key1 > b.key1 ? 
						1 : a.key2 < b.key2 ? -1 : a.key2 > b.key2 ? 1: 0 )});
		});
		
		vis.edges = vis.subBars[0].map(function(p,i){
			return {
				key1: p.key1,
				key2: p.key2,
				y1:p.y,
				y2:vis.subBars[1][i].y,
				h1:p.h,
				h2:vis.subBars[1][i].h
			};
		});
		vis.keys=data.keys;
		return vis;
	}
	
	function arcTween(a) {
		var i = d3.interpolate(this._current, a);
		this._current = i(0);
		return function(t) {
			return edgePolygon(i(t));
		};
	}
	
	function drawPart(data, id, p, percentatges){
		d3.select("#"+id).append("g").attr("class","part"+p)
			.attr("transform","translate("+( p*(bb+b))+",0)");
		d3.select("#"+id).select(".part"+p).append("g").attr("class","subbars");
		d3.select("#"+id).select(".part"+p).append("g").attr("class","mainbars");
		
		var mainbar = d3.select("#"+id).select(".part"+p).select(".mainbars")
			.selectAll(".mainbar").data(data.mainBars[p])
			.enter().append("g").attr("class","mainbar");

		mainbar.append("rect").attr("class","mainrect")//rectangles paisos
			.attr("x", 0).attr("y",function(d){ return d.middle-d.height/2; })
			.attr("width",5).attr("height",function(d){ return d.height; });
			
		mainbar.append("text").attr("class","barlabel")
			.attr("x", c1[p])
			.attr("y",function(d){ return d.middle+5;})
			.text(function(d,i){
                var country= data.keys[p][i];
                var country2= country.substr(0,14);
               if(country.length > 14 && p==0){
                   country=country2+"...";
               }
                return country;
            })
            .attr("text-anchor","start" );
         if(p==0 && $("#religion").val()!='all'){
                mainbar.append("title").text(function(d,i,p) {
                    var religion= $("#religion").find("option:selected").text();
                    var country= data.keys[p][i];
                    var text= "Country: "+country+"\n"+religion+": "+percentatges[data.keys[p][i]]+"%" ;
                    return text;
                })
         }
			
		mainbar.append("text").attr("class","barvalue")
			.attr("x", c2[p]).attr("y",function(d){ return d.middle+5;})
			.text(function(d,i){ return addCommas(d.value) ;})
			.attr("text-anchor","end");
			
		d3.select("#"+id).select(".part"+p).select(".subbars")
			.selectAll(".subbar").data(data.subBars[p]).enter()
			.append("rect").attr("class","subbar")
			.attr("x", 0).attr("y",function(d){ return d.y})
			.attr("width",5).attr("height",function(d){ return d.h})
			.style("fill",function(d){ return colors[d.key1];});
	}
	
	function drawEdges(data, id){
		d3.select("#"+id).append("g").attr("class","edges").attr("transform","translate("+ b+",0)");

		d3.select("#"+id).select(".edges").selectAll(".edge")
			.data(data.edges).enter().append("polygon").attr("class","edge")
			.attr("points", edgePolygon).style("fill",function(d){ return colors[d.key1];})
			.style("opacity",0.8).each(function(d) { this._current = d; });	
	}	
	
	function drawHeader(header, id){
        d3.select("#"+id).append("g").attr("class","header").append("text").text(header[2])
			.attr("x",128).attr("y",-6);
		
		[0,1].forEach(function(d){
			var h = d3.select("#"+id).select(".part"+d).append("g").attr("class","header");
			h.append("text").text(header[d]).attr("x", (c1[d]-5)).attr("y", -5);
			h.append("text").text("Count").attr("x", (c2[d]-40)).attr("y", -5);		
		});
	}
	
	function drawFooter(footer, id, other){
        var comarca= $("#destination").find("option:selected").text();

		if (comarca == "All regions") {comarca = "Catalonia";}

       var text_religion="(Roll over the country name to see the religiosity in origin)"
       var text;
        if($("#religion").val() == 'all'){
         text="Showing TOP 30 immigration origin countries: ";

        }else{
            d3.select("#"+id).append("g").attr("class","footer_text").append("text").text(text_religion).attr("x",20).attr("y",665);
            var religion= $("#religion").find("option:selected").text();
            if($("#religion").val() == 3){religion="Jehova's W.";}
           text="Countries with most % of practitioners (origin): ";
        }

		d3.select("#"+id).append("g").attr("class","footer_text").append("text").text(text).attr("x",20).attr("y",650);
       // d3.select("#"+id).append("g").attr("class","footer_text").append("text").text(text_religion).attr("x",20).attr("y",665);
		d3.select("#"+id).append("g").attr("class","footer_color").append("text").text(comarca).attr("x",290).attr("y",650);
        d3.select("#"+id).append("g").attr("class","footer_text_source").append("text").text("Source: IDESCAT").attr("x",490).attr("y",650);

        var text =addCommas(other);
        d3.select("#"+id).append("g").attr("class","footer_text_2").append("text").text("Others").attr("x",-180).attr("y",650);
        d3.select("#"+id).append("g").attr("class","footer_text_2").append("text").text(text).attr("text-anchor","end").attr("x",-30).attr("y",650);

        if ($("#country").val() != 'World' || $("#religion").val() != 'all')
        {
            d3.selectAll(".footer_text_2").remove();
        }
	}
	
	function edgePolygon(d){
	
		return [0, d.y1, bb, d.y2, bb, d.y2+d.h2, 0, d.y1+d.h1].join(" ");
	}	
	/*------------------------------------------------------------ TRANSITIONS ---------------------------------------*/
    function addCommas(nStr)
    {
        nStr += '';
        x = nStr.split('.');
        x1 = x[0];
        x2 = x.length > 1 ? '.' + x[1] : '';
        var rgx = /(\d+)(\d{3})/;
        while (rgx.test(x1)) {
            x1 = x1.replace(rgx, '$1' + ',' + '$2');
        }
        return x1 + x2;
    }

	function transitionPart(data, id, p){
		var mainbar = d3.select("#"+id).select(".part"+p).select(".mainbars")
			.selectAll(".mainbar").data(data.mainBars[p]);
		
		mainbar.select(".mainrect").transition().duration(500)
			.attr("y",function(d){ return d.middle-d.height/2;})
			.attr("height",function(d){ return d.height;});
			
		mainbar.select(".barlabel").transition().duration(500)
			.attr("y",function(d){ return d.middle+5;});
			
		mainbar.select(".barvalue").transition().duration(500)
			.attr("y",function(d){ return d.middle+5;}).text(function(d,i){ return addCommas(d.value) ;});
			
		mainbar.select(".barpercent").transition().duration(500)
			.attr("y",function(d){ return d.middle+5;})
			.text(function(d,i){ return "( "+Math.round(100*d.percent)+"%)" ;});
			
		d3.select("#"+id).select(".part"+p).select(".subbars")
			.selectAll(".subbar").data(data.subBars[p])
			.transition().duration(500)
			.attr("y",function(d){ return d.y}).attr("height",function(d){ return d.h});
	}
	
	function transitionEdges(data, id){
		d3.select("#"+id).append("g").attr("class","edges")
			.attr("transform","translate("+ b+",0)");

		d3.select("#"+id).select(".edges").selectAll(".edge").data(data.edges)
			.transition().duration(500)
			.attrTween("points", arcTween)
			.style("opacity",function(d){ return (d.h1 ==0 || d.h2 == 0 ? 0 : 0.8);});	
	}
	
	function transition(data, id){
		transitionPart(data, id, 0);
		transitionPart(data, id, 1);
		transitionEdges(data, id);
	}
	/*-----------------------------------  pinta grafic-------------------------------------------------------*/
	bP.draw = function(data, svg){
		data.forEach(function(biP,s){
			svg.append("g")
				.attr("id", biP.id)
				/*.attr("transform","translate("+ (550*s)+",0)")*/;
				
			var visData = visualize(biP.data);
			drawPart(visData, biP.id, 0, biP.percentatges );
			drawPart(visData, biP.id, 1, 0);
			drawEdges(visData, biP.id);
			drawHeader(biP.header, biP.id);
			drawFooter(biP.footer,biP.id, biP.other);
			
			[0,1].forEach(function(p){			
				d3.select("#"+biP.id)
					.select(".part"+p)
					.select(".mainbars")
					.selectAll(".mainbar")
					.on("mouseover",function(d, i){ return bP.selectSegment(data, p, i); })
					.on("mouseout",function(d, i){ return bP.deSelectSegment(data, p, i); });	
			});
		});	
	}
	//---------------------------Seleccio segment ----------------------------------

	bP.selectSegment = function(data, m, s){
		data.forEach(function(k){
			var newdata =  {keys:[], data:[]};	
				
			newdata.keys = k.data.keys.map( function(d){ return d;});
			
			newdata.data[m] = k.data.data[m].map( function(d){ return d;});
			
			newdata.data[1-m] = k.data.data[1-m]
				.map( function(v){ return v.map(function(d, i){ return (s==i ? d : 0);}); });
			
			transition(visualize(newdata), k.id);
				
			var selectedBar = d3.select("#"+k.id).select(".part"+m).select(".mainbars")
				.selectAll(".mainbar").filter(function(d,i){ return (i==s);});
			
			selectedBar.select(".mainrect").style("stroke-opacity",1);			
			selectedBar.select(".barlabel").classed("selected",true);
			selectedBar.select(".barvalue").classed("selected",true);

						
			if (m == 1 && $("#destination").val()=='Catalunya') { //color comarca només si col2 seleccionada
				console.log ( 'valor: '+newdata.keys[m][s] );
                cadena = newdata.keys[m][s];
                cadena2 = cadena.replace(/\s+/g, "_");
                console.log ( 'valor2: '+ cadena2 );
				d3.select("#mini_map_canvas #p_"+cadena2).style("fill", "#f55b2c");
			}
		});
	}
	
	

	
	//-------------------canvi de seleccio de segment---------------------
	bP.deSelectSegment = function(data, m, s){
		data.forEach(function(k){
			transition(visualize(k.data), k.id);
			
			var selectedBar = d3.select("#"+k.id).select(".part"+m).select(".mainbars")
				.selectAll(".mainbar").filter(function(d,i){ return (i==s);});
			
			selectedBar.select(".mainrect").style("stroke-opacity",0);			
			selectedBar.select(".barlabel").classed("selected", false);
			selectedBar.select(".barvalue").classed("selected", false);
			selectedBar.select(".barpercent").classed("selected", false);
			if (m == 1 && $("#destination").val()=='Catalunya') { //color comarca només si col2 seleccionada
				console.log ( 'valor: '+k.data.keys[m][s]);
                cadena = k.data.keys[m][s];
                cadena2 = cadena.replace(/\s+/g, "_");
                console.log ( 'valor2: '+ cadena2 );
                d3.select("#mini_map_canvas #p_"+cadena2).style("fill", "#cccccc");
			}
		});		
	}
	
	 
	
	
	this.bP = bP;
}();
